## ignition-msgs 5.1.0%2Bdfsg

=== src/CMakeLists.txt ===
##################################################
# Build a custom protoc plugin
ign_add_executable(ign_msgs_gen Generator.cc generator_main.cc)
target_link_libraries(ign_msgs_gen
  protobuf::libprotoc
  protobuf::libprotobuf)
target_include_directories(ign_msgs_gen PRIVATE ${PROTOBUF_INCLUDE_DIR})
target_compile_features(ign_msgs_gen PRIVATE ${IGN_CXX_11_FEATURES})

if (UNIX)
  target_link_libraries(ign_msgs_gen pthread)
endif()


##################################################
# A function that calls protoc on a protobuf file
# Options:
#   GENERATE_RUBY       - generates ruby code for the message if specified
#   GENERATE_CPP        - generates c++ code for the message if specified
# One value arguments:
#   PROTO_PACKAGE       - Protobuf package the file belongs to (e.g. ".ignition.msgs")
#   PROTOC_EXEC         - Path to protoc
#   INPUT_PROTO         - Path to the input .proto file
#   OUTPUT_CPP_DIR      - Path where C++ files are saved
#   OUTPUT_RUBY_DIR     - Path where Ruby files are saved
#   OUTPUT_CPP_HH_VAR   - A CMake variable name containing a list that the C++ header path should be appended to
#   OUTPUT_CPP_CC_VAR   - A Cmake variable name containing a list that the C++ source path should be appended to
#   OUTPUT_RUBY_VAR     - A Cmake variable name containing a list that the ruby file should be apenned to
# Multi value arguments
#   PROTO_PATH          - Passed to protoc --proto_path
function(ign_msgs_protoc)
  set(options GENERATE_RUBY GENERATE_CPP)
  set(oneValueArgs PROTO_PACKAGE PROTOC_EXEC INPUT_PROTO OUTPUT_CPP_DIR OUTPUT_RUBY_DIR OUTPUT_CPP_HH_VAR OUTPUT_CPP_CC_VAR OUTPUT_RUBY_VAR)
  set(multiValueArgs PROTO_PATH)

  cmake_parse_arguments(ign_msgs_protoc "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  get_filename_component(ABS_FIL ${ign_msgs_protoc_INPUT_PROTO} ABSOLUTE)
  get_filename_component(FIL_WE ${ign_msgs_protoc_INPUT_PROTO} NAME_WE)

  set(protoc_args)
  set(output_files)

  foreach(proto_path ${ign_msgs_protoc_PROTO_PATH})
    list(APPEND protoc_args "--proto_path=${proto_path}")
  endforeach()

  set(proto_package_dir ".")
  if(ign_msgs_protoc_PROTO_PACKAGE)
    string(REPLACE "." "/" proto_package_dir ${ign_msgs_protoc_PROTO_PACKAGE})
  endif()

  if(ign_msgs_protoc_GENERATE_CPP)
    set(output_header "${ign_msgs_protoc_OUTPUT_CPP_DIR}${proto_package_dir}/${FIL_WE}.pb.h")
    set(output_source "${ign_msgs_protoc_OUTPUT_CPP_DIR}${proto_package_dir}/${FIL_WE}.pb.cc")
    list(APPEND ${ign_msgs_protoc_OUTPUT_CPP_HH_VAR} ${output_header})
    list(APPEND ${ign_msgs_protoc_OUTPUT_CPP_CC_VAR} ${output_source})
    list(APPEND output_files ${output_header})
    list(APPEND output_files ${output_source})
    list(APPEND protoc_args "--plugin=protoc-gen-ignmsgs=$<TARGET_FILE:ign_msgs_gen>")
    list(APPEND protoc_args "--cpp_out=dllexport_decl=IGNITION_MSGS_VISIBLE:${ign_msgs_protoc_OUTPUT_CPP_DIR}")
    list(APPEND protoc_args "--ignmsgs_out" "${ign_msgs_protoc_OUTPUT_CPP_DIR}")
    set(${ign_msgs_protoc_OUTPUT_CPP_HH_VAR} ${${ign_msgs_protoc_OUTPUT_CPP_HH_VAR}} PARENT_SCOPE)
    set(${ign_msgs_protoc_OUTPUT_CPP_CC_VAR} ${${ign_msgs_protoc_OUTPUT_CPP_CC_VAR}} PARENT_SCOPE)
  endif()

  if(ign_msgs_protoc_GENERATE_RUBY)
    file(MAKE_DIRECTORY ${ign_msgs_protoc_OUTPUT_RUBY_DIR})
    set(output_ruby "${ign_msgs_protoc_OUTPUT_RUBY_DIR}${proto_package_dir}/${FIL_WE}_pb.rb")
    list(APPEND ${ign_msgs_protoc_OUTPUT_RUBY_VAR} ${output_ruby})
    list(APPEND output_files ${output_ruby})
    list(APPEND protoc_args "--ruby_out=${ign_msgs_protoc_OUTPUT_RUBY_DIR}")
    set(${ign_msgs_protoc_OUTPUT_RUBY_VAR} ${${ign_msgs_protoc_OUTPUT_RUBY_VAR}} PARENT_SCOPE)
  endif()

  #get_cmake_property(_variableNames VARIABLES)
  #foreach (_variableName ${_variableNames})
  #    message(STATUS "${_variableName}=${${_variableName}}")
  #endforeach()

  add_custom_command(
    OUTPUT
      ${output_files}
    COMMAND
      ${ign_msgs_protoc_PROTOC_EXEC}
    ARGS
      ${protoc_args}
      ${ABS_FIL}
    DEPENDS
      ${ABS_FIL}
      ign_msgs_gen
    COMMENT "Running protoc on ${ign_msgs_protoc_INPUT_PROTO}"
    VERBATIM)
endfunction()


##################################################
# do the code generation
file (GLOB proto_files ${PROJECT_SOURCE_DIR}/proto/ignition/msgs/*.proto)

foreach(proto_file ${proto_files})
  ign_msgs_protoc(
    PROTO_PACKAGE
      .ignition.msgs
    GENERATE_CPP
    GENERATE_RUBY
    INPUT_PROTO
      ${proto_file}
    PROTOC_EXEC
      protobuf::protoc
    OUTPUT_CPP_DIR
      "${PROJECT_BINARY_DIR}/include"
    OUTPUT_RUBY_DIR
      "${PROJECT_BINARY_DIR}/ruby"
    OUTPUT_CPP_HH_VAR
      gen_headers
    OUTPUT_CPP_CC_VAR
      gen_sources
    OUTPUT_RUBY_VAR
      gen_ruby_scripts
    PROTO_PATH
      "${PROJECT_SOURCE_DIR}/proto")
endforeach()

if(NOT MSVC)
  # -Wno-switch-default flags is required for suppressing a warning in some of
  # the generated protobuf files.
  set_source_files_properties(${gen_sources} COMPILE_FLAGS -Wno-switch-default)
endif()

if(MSVC)
  # Warning #4251 is the "dll-interface" warning that tells you when types used
  # by a class are not being exported. These generated source files have private
  # members that don't get exported, so they trigger this warning. However, the
  # warning is not important since those members do not need to be interfaced
  # with.
  set_source_files_properties(${gen_sources} COMPILE_FLAGS "/wd4251 /wd4146")
endif()

set_source_files_properties(${gen_headers} ${gen_sources} ${gen_ruby_scripts}
  PROPERTIES GENERATED TRUE)

message(STATUS "Installing Ruby messages to ${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ruby/ignition/${IGN_DESIGNATION}${PROJECT_VERSION_MAJOR}")
install(FILES ${gen_ruby_scripts} DESTINATION ${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ruby/ignition/${IGN_DESIGNATION}${PROJECT_VERSION_MAJOR})

ign_install_includes(
  "${IGN_INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_DESIGNATION}"
  ${gen_headers})


##################################################
# Generate ignition/msgs/MessageTypes.hh
foreach (hdr ${gen_headers})
  string(REPLACE "${PROJECT_BINARY_DIR}/include/" "" hdr ${hdr})
  string(CONCAT ign_msgs_headers ${ign_msgs_headers} "#include <${hdr}>\n")
endforeach()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/MessageTypes.hh.in
  ${PROJECT_BINARY_DIR}/include/ignition/msgs/MessageTypes.hh)

ign_install_includes(
  "${IGN_INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_DESIGNATION}"
  "${PROJECT_BINARY_DIR}/include/ignition/${IGN_DESIGNATION}/MessageTypes.hh")


##################################################
# Build the main library
ign_create_core_library(SOURCES
  ${gen_sources}
  ${PROJECT_SOURCE_DIR}/src/Factory.cc
  ${PROJECT_SOURCE_DIR}/src/Filesystem.cc
  ${PROJECT_SOURCE_DIR}/src/ign.cc
  ${PROJECT_SOURCE_DIR}/src/Utility.cc
  CXX_STANDARD 17)

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    protobuf::libprotobuf
    ${ignition-math${IGN_MATH_VER}_LIBRARIES}
  PRIVATE
    TINYXML2::TINYXML2
)

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  SYSTEM PUBLIC $<TARGET_PROPERTY:protobuf::libprotobuf,INTERFACE_INCLUDE_DIRECTORIES>)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # Disable warning in generated *.pb.cc code
  target_compile_options(${PROJECT_LIBRARY_TARGET_NAME} PRIVATE -Wno-extended-offsetof)
endif()

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR_FULL}>)

##################################################
# Build unit tests
ign_get_libsources_and_unittests(sources gtest_sources)

# Build the unit tests.
ign_build_tests(TYPE UNIT
  SOURCES
    ${gtest_sources}
  LIB_DEPS
      TINYXML2::TINYXML2
)

##################################################
# ign msgs command
if(NOT WIN32)
  add_subdirectory(cmd)
endif()

=== debian/changelog ===
ignition-msgs (5.1.0+dfsg-7) unstable; urgency=medium

  * Team upload.
  * Use protobuf-api-* package dependency (Closes: #980714)
  * bump policy and debhelper versions

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 21 Jan 2021 15:46:16 +0100

ignition-msgs (5.1.0+dfsg-6) unstable; urgency=medium

  * Team upload.
  * Don't rely on IFS to split substvars

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 13 Oct 2020 23:50:32 +0200

ignition-msgs (5.1.0+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Add awk build dependency (for protobuf version in d/rules)
  * Add provides libignition-msgs*-protobuf$abi package

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 16 Jul 2020 15:06:26 +0200

ignition-msgs (5.1.0+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Restrict protobuf dependency to current version

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 14 Jul 2020 23:10:56 +0200

ignition-msgs (5.1.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Disable failing Tests
  * Fix aptopkgtest and update dependencies

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 18 Apr 2020 19:17:54 +0200

ignition-msgs (5.1.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Update d/watch to Github (switch suffix to ds)
  * Upload to unstable.

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 18 Apr 2020 11:32:01 +0200

ignition-msgs (5.1.0+dfsg-1) experimental; urgency=medium

  * Team upload.
  * Update d/watch
  * New upstream version 5.1.0+dfsg
  * Rebase patch
  * Update copyright
  * Rename packages (new API)
  * Update dependencies
  * bump policy and debhelper versions (no changes)
  * Cleanup debian/

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 13 Apr 2020 16:08:02 +0200

=== debian/control ===
Source: ignition-msgs
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper-compat (= 13),
               libgtest-dev,
               libprotoc-dev,
               libprotobuf-dev (>= 2.3.0),
               libignition-math-dev (>= 6),
               libignition-cmake-dev (>= 2),
               protobuf-compiler,
               libtinyxml2-dev,
               mawk | awk,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/ignition-msgs
Vcs-Git: https://salsa.debian.org/science-team/ignition-msgs.git
Homepage: https://ignitionrobotics.org/libs/msgs

Package: libignition-msgs5-5
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${ignition:Provides}
Multi-Arch: same
Description: Set of message definitions used by robotics apps - Shared library
 Ignition msgs is a component in the Ignition framework, a set of
 librariesdesigned to rapidly develop robot applications. The library
 defines common protobuf messages used by the robotics community.
 This package contains the main message library.

Package: libignition-msgs-dev
Architecture: any
Section: libdevel
Depends: ${protobuf:API},
         libprotoc-dev,
         protobuf-compiler,
         libignition-math-dev (>= 6),
         libignition-cmake-dev (>= 2),
         libtinyxml2-dev,
         libignition-msgs5-5 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Set of message definitions used by robotics apps - Dev files
 Ignition msgs is a component in the Ignition framework, a set of
 librariesdesigned to rapidly develop robot applications. The library
 defines common protobuf messages used by the robotics community.
 This package contains the headers and other tools for development.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

SOVERSION := 5-5

# see #963247, #980423
# extract the protobuf API version package and add it to d/control
# Needed because protobuf generated headers are only compatible with that version
protobufapi := $(shell dpkg-query -W -f '$${Provides}' libprotobuf-dev | grep -o 'protobuf-api-[^ ]*')

# virtual package to represent libignition-msgs and protobuf ABI
ignitionprotoabi := libignition-msgs$(SOVERSION)-protobuf$(shell dpkg-query -W -f '$${Depends}' libprotobuf-dev | sed -n 's/.*libprotobuf\([0-9]*\) .*/\1/p')

override_dh_auto_configure:
	dh_auto_configure -- \
                -DUSE_HOST_SSE_FLAGS:BOOL=False \
                -DUSE_IGN_RECOMMENDED_FLAGS:BOOL=False

%:
	dh $@

execute_before_dh_gencontrol:
	echo 'ignition:Provides=$(ignitionprotoabi)' >> debian/libignition-msgs$(SOVERSION).substvars
	echo 'protobuf:API=$(protobufapi)' >> debian/libignition-msgs-dev.substvars

override_dh_makeshlibs:
	dh_makeshlibs -plibignition-msgs$(SOVERSION) -V '$(ignitionprotoabi)'
	dh_makeshlibs --remaining-packages

## ignition-msgs 5.1.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-msgs5 VERSION 5.1.0)

#============================================================================
# Find ignition-cmake
#============================================================================
# If you get an error at this line, you need to install ignition-cmake
find_package(ignition-cmake2 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
ign_configure_project()

#============================================================================
# Set project-specific options
#============================================================================

# ignition-msgs currently has no options that are unique to it

#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find Protobuf
set(REQ_PROTOBUF_VER 3)
ign_find_package(IgnProtobuf
                 VERSION ${REQ_PROTOBUF_VER}
                 REQUIRED
                 COMPONENTS all
                 PRETTY Protobuf)

#--------------------------------------
# Find ignition-math
ign_find_package(ignition-math6 REQUIRED)
set(IGN_MATH_VER ${ignition-math6_VERSION_MAJOR})

#--------------------------------------
# Find ignition-tools
ign_find_package(ignition-tools
                 QUIET)

#--------------------------------------
# Find Tinyxml2
ign_find_package(TINYXML2 REQUIRED PRIVATE PRETTY tinyxml2)

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS)

#============================================================================
# ign command line support
#============================================================================
add_subdirectory(conf)

#============================================================================
# Test the command line commands
#============================================================================
add_subdirectory(tools)

#============================================================================
# Install proto files
#============================================================================
# TODO: Consider tweaking ign_configure_build() to call add_subdirectory(proto)
# whenever a proto subdirectory exists. This could be used alongside
# ign_msgs_protoc to get uniform support for proto messages across all ignition
# projects.
add_subdirectory(proto)

#============================================================================
# Create package information
#============================================================================
ign_create_packages()

#============================================================================
# Create documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)


ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md"
  TAGFILES
    "${IGNITION-MATH_DOXYGEN_TAGFILE} = ${IGNITION-MATH_API_URL}"
)

=== tools/CMakeLists.txt ===
include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/test
)
set (test_sources
  ign_TEST.cc
)

# Skip command line tests for Windows, see
# https://bitbucket.org/ignitionrobotics/ign-msgs/issues/28
if (MSVC)
  list(REMOVE_ITEM test_sources ign_TEST.cc)
endif()

if (IGNITION-TOOLS_BINARY_DIRS)
  ign_build_tests(TYPE UNIT SOURCES ${test_sources})
endif ()

=== debian/changelog ===
ignition-msgs (5.1.0+dfsg-5build1) groovy; urgency=medium

  * Rebuild against new libprotobuf23.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 26 Jul 2020 10:15:20 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: optional
 Build-Depends: cmake,
                pkg-config,
-               debhelper-compat (= 13),
+               debhelper-compat (= 12),
                libgtest-dev,
                libprotoc-dev,
                libprotobuf-dev (>= 2.3.0),
@@ -14,7 +14,7 @@
                protobuf-compiler,
                libtinyxml2-dev,
                mawk | awk,
-Standards-Version: 4.5.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/ignition-msgs
 Vcs-Git: https://salsa.debian.org/science-team/ignition-msgs.git
@@ -36,7 +36,8 @@
 Package: libignition-msgs-dev
 Architecture: any
 Section: libdevel
-Depends: ${protobuf:API},
+Depends: libprotobuf-dev (>= ${protobuf:Upstream-Version}),
+         libprotobuf-dev (<< ${protobuf:Upstream-Version-Next}),
          libprotoc-dev,
          protobuf-compiler,
          libignition-math-dev (>= 6),

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

SOVERSION := 5-5

# see #963247
# compute current and next protobuf minor version and add it to d/control
# Needed because protobuf generated headers are only compatible with that version
protobufvercurr := $(shell dpkg-query -W -f '$${Source:Upstream-Version}' libprotobuf-dev | awk -F. '{print $$1"."$$2}')
protobufvernext := $(shell dpkg-query -W -f '$${Source:Upstream-Version}' libprotobuf-dev | awk -F. '{print $$1"."$$2+1}')

# virtual package to represent libignition-msgs and protobuf ABI
ignitionprotoabi := libignition-msgs$(SOVERSION)-protobuf$(shell dpkg-query -W -f '$${Depends}' libprotobuf-dev | sed -n 's/.*libprotobuf\([0-9]*\) .*/\1/p')

override_dh_auto_configure:
	dh_auto_configure -- \
                -DUSE_HOST_SSE_FLAGS:BOOL=False \
                -DUSE_IGN_RECOMMENDED_FLAGS:BOOL=False

%:
	dh $@

execute_before_dh_gencontrol:
	echo 'ignition:Provides=$(ignitionprotoabi)' >> debian/libignition-msgs$(SOVERSION).substvars
	echo 'protobuf:Upstream-Version=$(protobufvercurr)\nprotobuf:Upstream-Version-Next=$(protobufvernext)' >> debian/libignition-msgs-dev.substvars

override_dh_makeshlibs:
	dh_makeshlibs -plibignition-msgs$(SOVERSION) -V '$(ignitionprotoabi)'
	dh_makeshlibs --remaining-packages

## ignition-msgs 8.2.0%2Bds

=== test/integration/CMakeLists.txt ===

ign_get_sources(tests)

if(MSVC)
  # TODO: Check if/why this test doesn't work on Windows and find a fix.
  list(REMOVE_ITEM tests headers.cc)
endif()

ign_build_tests(TYPE INTEGRATION SOURCES ${tests})

## ignition-msgs 8.2.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,24 +3,51 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-msgs5 VERSION 5.1.0)
+project(ignition-msgs8 VERSION 8.2.0)
 
 #============================================================================
 # Find ignition-cmake
 #============================================================================
 # If you get an error at this line, you need to install ignition-cmake
-find_package(ignition-cmake2 REQUIRED)
+find_package(ignition-cmake2 2.8.0 REQUIRED)
 
 #============================================================================
 # Configure the project
 #============================================================================
-ign_configure_project()
+ign_configure_project(VERSION_SUFFIX)
 
 #============================================================================
 # Set project-specific options
 #============================================================================
 
-# ignition-msgs currently has no options that are unique to it
+# Cross-compilation related options
+# In a cross-compilation scenario, it is possible that the ign_msgs_gen
+# generator compiled for the target machine cannot be used to generate
+# the C++ code corresponding to the .proto definition. For this scenario,
+# the following two options can be used as follows.
+# First of all, ign-msgs is compiled targeting the host machine, and in the
+# build targeting the host, the INSTALL_IGN_MSGS_GEN_EXECUTABLE option is
+# enabled:
+# > cmake -DINSTALL_IGN_MSGS_GEN_EXECUTABLE:BOOL=ON ..
+# ensuring that the ign_msgs_gen is installed in
+# <host_install_prefix>/bin/ign_msgs_gen . Then, the same version of ign-msgs
+# can be cross-compiled, and in the cross-compilation build the location of the
+# host ign_msgs_gen is specified via the IGN_MSGS_GEN_EXECUTABLE
+# CMake cache variable:
+# > cmake -IGN_MSGS_GEN_EXECUTABLE=<host_install_prefix>/bin/ign_msgs_gen ..
+
+option(
+  INSTALL_IGN_MSGS_GEN_EXECUTABLE
+  "Install the ign_msgs_gen executable."
+  OFF)
+mark_as_advanced(INSTALL_IGN_MSGS_GEN_EXECUTABLE)
+
+set(
+  IGN_MSGS_GEN_EXECUTABLE
+  "$<TARGET_FILE:ign_msgs_gen>"
+  CACHE STRING
+  "ign_msgs_gen executable used in the ign_msgs_protoc CMake function.")
+mark_as_advanced(IGN_MSGS_GEN_EXECUTABLE)
 
 #============================================================================
 # Search for project-specific dependencies
@@ -38,13 +65,12 @@
 
 #--------------------------------------
 # Find ignition-math
-ign_find_package(ignition-math6 REQUIRED)
+ign_find_package(ignition-math6 REQUIRED VERSION 6.5)
 set(IGN_MATH_VER ${ignition-math6_VERSION_MAJOR})
 
 #--------------------------------------
-# Find ignition-tools
-ign_find_package(ignition-tools
-                 QUIET)
+# Find if ign command is available
+find_program(HAVE_IGN_TOOLS ign)
 
 #--------------------------------------
 # Find Tinyxml2
@@ -89,6 +115,13 @@
 ign_create_docs(
   API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
   TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md"
+  AUTOGENERATED_DOC "${CMAKE_BINARY_DIR}/include/ignition/msgs/"
   TAGFILES
     "${IGNITION-MATH_DOXYGEN_TAGFILE} = ${IGNITION-MATH_API_URL}"
 )
+
+# Wait to build the doc for the autogenerated code
+# The TARGET will exist if doxygen is installed
+if(TARGET doc)
+  add_dependencies(doc ignition-msgs${PROJECT_VERSION_MAJOR})
+endif()

=== proto/CMakeLists.txt ===

install(
  DIRECTORY ignition
  DESTINATION "${IGN_INCLUDE_INSTALL_DIR_FULL}"
  COMPONENT proto
  FILES_MATCHING PATTERN "*.proto")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,10 @@
   target_link_libraries(ign_msgs_gen pthread)
 endif()
 
+if(INSTALL_IGN_MSGS_GEN_EXECUTABLE)
+  set_target_properties(ign_msgs_gen PROPERTIES VERSION ${PROJECT_VERSION_FULL})
+  install(TARGETS ign_msgs_gen DESTINATION ${IGN_BIN_INSTALL_DIR})
+endif()
 
 ##################################################
 # A function that calls protoc on a protobuf file
@@ -57,7 +61,7 @@
     list(APPEND ${ign_msgs_protoc_OUTPUT_CPP_CC_VAR} ${output_source})
     list(APPEND output_files ${output_header})
     list(APPEND output_files ${output_source})
-    list(APPEND protoc_args "--plugin=protoc-gen-ignmsgs=$<TARGET_FILE:ign_msgs_gen>")
+    list(APPEND protoc_args "--plugin=protoc-gen-ignmsgs=${IGN_MSGS_GEN_EXECUTABLE}")
     list(APPEND protoc_args "--cpp_out=dllexport_decl=IGNITION_MSGS_VISIBLE:${ign_msgs_protoc_OUTPUT_CPP_DIR}")
     list(APPEND protoc_args "--ignmsgs_out" "${ign_msgs_protoc_OUTPUT_CPP_DIR}")
     set(${ign_msgs_protoc_OUTPUT_CPP_HH_VAR} ${${ign_msgs_protoc_OUTPUT_CPP_HH_VAR}} PARENT_SCOPE)
@@ -135,6 +139,8 @@
   # warning is not important since those members do not need to be interfaced
   # with.
   set_source_files_properties(${gen_sources} COMPILE_FLAGS "/wd4251 /wd4146")
+  # Fix for protobuf 3.12 - allow big object files
+  add_definitions(/bigobj)
 endif()
 
 set_source_files_properties(${gen_headers} ${gen_sources} ${gen_ruby_scripts}
@@ -179,7 +185,7 @@
 target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
   PUBLIC
     protobuf::libprotobuf
-    ${ignition-math${IGN_MATH_VER}_LIBRARIES}
+    ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER}
   PRIVATE
     TINYXML2::TINYXML2
 )

=== tools/CMakeLists.txt ===
include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/test
)
set (test_sources
  ign_TEST.cc
)

# Skip command line tests for Windows, see
# https://github.com/ignitionrobotics/ign-msgs/issues/28
if (MSVC)
  list(REMOVE_ITEM test_sources ign_TEST.cc)
endif()


if (HAVE_IGN_TOOLS)
  ign_build_tests(TYPE UNIT SOURCES ${test_sources})
endif ()

=== test/performance/CMakeLists.txt ===

ign_get_sources(tests)

ign_build_tests(TYPE PERFORMANCE SOURCES ${tests})

=== include/ignition/msgs/CMakeLists.txt ===
ign_install_all_headers(
  GENERATED_HEADERS
    MessageTypes.hh)

=== debian/changelog ===
ignition-msgs (8.2.0+ds-1) unstable; urgency=medium

  * New upstream version 8.2.0+ds

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 31 Jan 2022 22:57:24 +0000

ignition-msgs (8.1.0+ds-4) unstable; urgency=medium

  * Team upload.
  * Add an other break for old downstream packages

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 29 Jan 2022 20:55:27 +0100

ignition-msgs (8.1.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Fix multi arch path in file
  * Drop unused build dependency
  * Breaks autopkgtest of old ignition-fuel-tools

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 29 Jan 2022 13:18:02 +0100

ignition-msgs (8.1.0+ds-2) unstable; urgency=medium

  * Move to unstable

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 11 Jan 2022 18:22:37 +0000

ignition-msgs (8.1.0+ds-1) experimental; urgency=medium

  * New upstream version 8.1.0+ds
  * Updated metadata to SOVERSION 8
  * Move not installed files to -dev
  * Update copyright

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 12 Nov 2021 15:46:39 +0000

ignition-msgs (7.1.0+ds-1) unstable; urgency=medium

  * Update standards version
  * Change metadata for the new major version
  * New upstream version 7.1.0+ds

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 25 Aug 2021 20:05:37 +0000

=== debian/control ===
--- 
+++ 
@@ -5,22 +5,22 @@
 Priority: optional
 Build-Depends: cmake,
                pkg-config,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libgtest-dev,
                libprotoc-dev,
                libprotobuf-dev (>= 2.3.0),
                libignition-math-dev (>= 6),
                libignition-cmake-dev (>= 2),
+               ignition-tools,
                protobuf-compiler,
                libtinyxml2-dev,
-               mawk | awk,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/ignition-msgs
 Vcs-Git: https://salsa.debian.org/science-team/ignition-msgs.git
 Homepage: https://ignitionrobotics.org/libs/msgs
 
-Package: libignition-msgs5-5
+Package: libignition-msgs8-8
 Architecture: any
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
@@ -36,16 +36,17 @@
 Package: libignition-msgs-dev
 Architecture: any
 Section: libdevel
-Depends: libprotobuf-dev (>= ${protobuf:Upstream-Version}),
-         libprotobuf-dev (<< ${protobuf:Upstream-Version-Next}),
+Depends: ${protobuf:API},
          libprotoc-dev,
          protobuf-compiler,
          libignition-math-dev (>= 6),
          libignition-cmake-dev (>= 2),
          libtinyxml2-dev,
-         libignition-msgs5-5 (= ${binary:Version}),
+         libignition-msgs8-8 (= ${binary:Version}),
          ${misc:Depends}
 Multi-Arch: same
+Breaks: libignition-fuel-tools-dev (<< 7),
+        libignition-transport-dev (<< 11),
 Description: Set of message definitions used by robotics apps - Dev files
  Ignition msgs is a component in the Ignition framework, a set of
  librariesdesigned to rapidly develop robot applications. The library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

SOVERSION := 8-8

# see #963247, #980423
# extract the protobuf API version package and add it to d/control
# Needed because protobuf generated headers are only compatible with that version
protobufapi := $(shell dpkg-query -W -f '$${Provides}' libprotobuf-dev | grep -o 'protobuf-api-[^ ]*')

# virtual package to represent libignition-msgs and protobuf ABI
ignitionprotoabi := libignition-msgs$(SOVERSION)-protobuf$(shell dpkg-query -W -f '$${Depends}' libprotobuf-dev | sed -n 's/.*libprotobuf\([0-9]*\) .*/\1/p')

override_dh_auto_configure:
	dh_auto_configure -- \
                -DUSE_HOST_SSE_FLAGS:BOOL=False \
                -DUSE_IGN_RECOMMENDED_FLAGS:BOOL=False

%:
	dh $@

execute_after_dh_auto_install:
	# Drop multi arch from library path
	sed -i "s@LIBRARY_NAME = '.*/@LIBRARY_NAME = '@" debian/tmp/usr/lib/ruby/ignition/cmdmsgs8.rb

execute_before_dh_gencontrol:
	echo 'ignition:Provides=$(ignitionprotoabi)' >> debian/libignition-msgs$(SOVERSION).substvars
	echo 'protobuf:API=$(protobufapi)' >> debian/libignition-msgs-dev.substvars

override_dh_makeshlibs:
	dh_makeshlibs -plibignition-msgs$(SOVERSION) -V '$(ignitionprotoabi)'
	dh_makeshlibs --remaining-packages

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
    dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,repacksuffix=+ds \
    https://github.com/ignitionrobotics/ign-msgs/tags \
		(?:.*?/)@PACKAGE@.*_(\d[\d.]*)\.tar\.gz
